<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<HTML>
    <HEAD>
        <TITLE>Database deadlock test Documentation</TITLE>
    </HEAD>

    <BODY>
        <H1 align="center">How to run deadlock test </H1>

        <P>This is a test that exercises metadataAPI handling of simultaneous requests
		of putMetaData and getMetaData short and long queries. The test objective is
		to validate that metadataAPI
		<UL>
		<LI>does not deadlock when processing long queries</LI><p>		
		<LI>handles multiple requests simultaneously</LI><p>
		</UL>
		
		<P>The LDAS APIs affected by this test are:
		<UL>
		<LI><font color='blue'>managerAPI</font>: directs processing of the insertion user commands to the ligolwAPI and metadataAPI
			and returns the user command status to the user.</LI><p>
		<LI><font color='blue'>ligolwAPI</font>: 
			<UL>
			<LI>Retrieves the data to be ingested from the specified url to ilwd object and sends the ilwd
			to the metadataAPI for insertion or 
			<LI>Converts the ilwd from metadata into LIGO_LW format for output to user.</LI><p>
			</UL><p>
		<LI><font color='blue'>metadataAPI</font>: 
			<UL>
			<LI>insert the metadata ilwd data from ligolwAPI into the specified database.</LI>
			<LI>process the user query and sends result ilwd to ligolwAPI.</LI>
			</UL>
		</UL>
		
		
        <H2>Setup</H2>
        <P>Choose a directory to install the tests scripts.  
		<UL>
		<LI>The script files are:

        <P><CODE><font color='blue'>deadlock.test</font> - main driver script<BR>
        <font color='blue'>TrigMgr20001208205115000006010000.xml</font> - data to insert,
		 any xml that inserts correctly<BR>
		<font color='blue'>metadata_test.tcl</font> - user command test driver<BR>
		<font color='blue'>getMetaData.tcl</font> - getMetaData user command test driver<BR>
		<font color='blue'>putMetaData.tcl</font> - putMetaData user command test driver<BR>
		<font color='blue'>testlib.tcl</font> - handle sending commands and receiving of results<BR>
		</CODE></LI><p>
				
        <P><B>Note:</B> The above files should be installed on your local platform.<CODE></CODE>.  
		</UL>
        <H2>Running the test</H2>
		The test should be run from your local platform, and run in the scripts directory.
		
		<p>cd &lt;scripts directory&gt;<p>
		
        <B>Usage:</B> <CODE>deadlock.test [options] >& deadlock.log & </CODE>

        <P><TABLE border=1 cellspacing=0 cellpadding=10>0 
            <TR>
                <TH><B>Option</B>
                <TH><B>Description</B>
			<TR>
                <TD valign=top><CODE>&lt;repeat times&gt;</TD><TD>number of times to cycle through e.g. 10 will cycle through the test 10 times</TD></CODE>
        </TABLE><p>
		Each cycle of the test consists of :<p>
		<UL>
		<LI>putMetaData request</LI><p>
		<LI>a long query selecting sngl_inspiral data from a subset of process_ids generated by a subquery to the process table.</LI><p>
		<LI>short queries on other tables in the database.</LI><p>
		</UL>
		It is highly desirable to have the database populated with a lot of rows e.g. 200000 process records
		and sngl_inspirals and at least some data in the following tables:<pre>
	runlist process process_params sngl_burst search_summvars summ_spectrum search_summary summ_value
		</pre>
		<H2>Test Verification:</H2>
		<OL>
		<LI>putMetaData errors should only be from duplicates</LI>
		<LI>getMetaData short queries should be able to pass through metadataAPI</LI>
		<LI>Long getMetaData queries on the sngl_inspiral table may be present for a long time but should eventually complete.</LI>
		<LI>Use cmonClient log filter to extract the logs during the test period with regular expression deleteSlave. The logs
		should show presences of multiple interps at a given instant: <pre>
	called from metadataSlave::submitInsertReaper, Remaining slaves: interp2 interp0 interp1'
		</pre>
		</OL>
		
		<i>Note: since there is a potential deadlock between two LDAS APIs that send and receive to each other
		this test could run into the deadlock situation when the ligolwAPI and the metadataAPI are sending data
		to each other at exactly the same time. </i>
		<p>
    </BODY>
</HTML>

